=== debian/changelog ===
ros-noetic-cras-topic-tools (2.1.2-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 09 Feb 2023 23:00:00 -0000

ros-noetic-cras-topic-tools (2.1.1-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 07 Feb 2023 23:00:00 -0000

ros-noetic-cras-topic-tools (2.1.0-1buster) buster; urgency=high

  * Added cras::ShapeShifter as a memory-safe option for Melodic.
  * Added a method to convert a message instance to ShapeShifter.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 07 Feb 2023 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.10-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.9-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.8-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.7-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.6-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 23 Nov 2022 23:00:00 -0000

ros-noetic-cras-topic-tools (2.0.5-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 22 Oct 2022 22:00:00 -0000

ros-noetic-cras-topic-tools (2.0.4-1buster) buster; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 13 Oct 2022 22:00:00 -0000

ros-noetic-cras-topic-tools (2.0.3-1buster) buster; urgency=high

  * Lower test_repeat thresholds even more, OSRF buildfarm is really bad at this
  * cras_py_common: Extended functionality to get closer to cras_cpp_common.
  * Improved readmes and added more badges to them.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 06 Oct 2022 22:00:00 -0000

ros-noetic-cras-topic-tools (2.0.2-1buster) buster; urgency=high

  * Added option to change_header to apply current ROS time to stamp.
  * De-flake throttle test and enable catkin_lint when it has chance to run correctly.
  * Satisfy more pedantic Noetic linter.
  * Added website links.
  * Add linters and licenses.
  * Fixed dependency.
  * Added linters.
  * Fix catkin_lint, re-enable testing.
  * Improved comments in nodelet.xml.
  * De-flake and speed up throttle test.
  * De-flake and speed up repeater test.
  * De-flake and speed up relay test.
  * De-flake and speed up filter test.
  * De-flake and speed up change_header test.
  * Avoid threading errors when stopping nodes created by node_from_nodelet.
  * Fix compilation on GCC 7.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sun, 28 Aug 2022 22:00:00 -0000

ros-noetic-cras-topic-tools (2.0.1-1buster) buster; urgency=high

  * Moved hack_frame_id from cras_py_common to cras_topic_tools.
  * Moved launch files.
  * Merged cras_nodelet_topic_tools with cras_topic_tools, moved repeater and joy_repeater from cras_cpp_common to cras_topic_tools.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 25 Aug 2022 22:00:00 -0000
