=== debian/control ===
Source: ros-noetic-cras-topic-tools
Section: misc
Priority: optional
Maintainer: Martin Pecka <peckama2@fel.cvut.cz>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, python3-catkin-lint <!nocheck>, ros-noetic-catkin, ros-noetic-cras-cpp-common, ros-noetic-cras-msgs, ros-noetic-geometry-msgs <!nocheck>, ros-noetic-nodelet, ros-noetic-rosbag, ros-noetic-roscpp, ros-noetic-roslaunch <!nocheck>, ros-noetic-roslint <!nocheck>, ros-noetic-rostest <!nocheck>, ros-noetic-rostopic <!nocheck>, ros-noetic-std-msgs, ros-noetic-std-msgs <!nocheck>, ros-noetic-topic-tools
Homepage: https://wiki.ros.org/cras_topic_tools
Standards-Version: 3.9.2

Package: ros-noetic-cras-topic-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-noetic-cras-cpp-common, ros-noetic-cras-msgs, ros-noetic-cras-py-common, ros-noetic-nodelet, ros-noetic-rosbag, ros-noetic-roscpp, ros-noetic-rospy, ros-noetic-std-msgs, ros-noetic-topic-tools
Description: Nodes and nodeletes for safe and efficient manipulation with topics
